function htmlspecialchars (t) {
	if (!t) return ("");
	return (t.toString().replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;'));
	}

function to_html (t) {
	var s = " \t\r\n<>\[\],;";	// Stop characters for URLs
	result = '';
	if (t) {
		var n = t.length;
		var k = 0;
		while ((j = t.indexOf("http",k)) != -1) {
			result += t.substr(k,j-k);
			for (m=0; m + j < n; m++)
				if (s.indexOf(t.charAt(j+m)) != -1) break;
			var url = t.substr (j,m);
			result += "<a href=\"" + url + "\" target=\"_blank\" title=\"opens in a new window\">" + htmlspecialchars(url) + "</a>";
			k = j + m;
			}
		result += htmlspecialchars (t.substr(k));
		}
	return (result);
	}

function show_use_with (the_thcode, the_text) {
	$.ajax({
		url: "https://www2.usgs.gov/science/term.php",
		dataType: "jsonp",
		data: {
			text:   the_text,
			thcode: the_thcode
			},
		success: function (data) {
			/* Focused item is a use-with term */
			if (Array.isArray(data)) {
				var d = "<div class=\"descriptor\">";

				var the_text = "";
				if (data.length == 2) {
					var p = data[0];
					var q = data[1];
					$.each(p.uf,function(j) {
						if (this.usewith && this.usewith.code == q.term.code) {
							if (the_text.length == 0) the_text = this.name;
							else the_text += ", " + this.name;
							}
						});
					}
				if (the_text.length == 0) the_text = "Coordinated terms";

				d += "<div class=\"this-term\">" + the_text + "</div>";
				d += "<div class=\"sn\">Information about ";
				$.each(data,function(i) {
					if (i > 0) d += " and ";
					d += "<a href=\"/catalog/science.php?thcode=" + this.thcode + "&amp;code=" + this.term.code + "\"";
					d += " onclick=\"show_term(" + this.thcode + ",'" + this.term.code + "'); return false;\"";
					if (this.term.scope != null && this.term.scope.length > 0) d += " title=\"" + htmlspecialchars(this.term.scope) + "\"";
					d += ">";
					d += this.term.name;
					d += "</a>";
					});
				d += "</div>";
				d += "</div>";

				$("#thesaurus-" + the_thcode).html("<div>" + d + "</div>");
				}
			else {
				/* Ideally show_term should have been called in this case */
				}
			}
		});
	}

function show_term (the_thcode,the_code) {
	$.ajax({
		url: "https://www2.usgs.gov/science/term.php",
		dataType: "jsonp",
		data: {
			code:   the_code,
			thcode: the_thcode
			},
		success: function (data) {
			var thcode = the_thcode;
			var bt = "";
			var n = data["bt"].length;
			$.each(data["bt"],function(index) {
				var b = "";
				if (index < n - 1) b += " &gt; ";
				b += "<a href=\"/catalog/science.php?thcode=" + thcode + "&amp;term=" + this.code + "\"";
				b += " onclick=\"show_term(" + thcode + ",'" + this.code + "'); return false;\"";
				if (this.scope != null && this.scope.length > 0) b += " title=\"" + htmlspecialchars(this.scope) + "\"";
				b += ">";
				b += this.name;
				b += "</a>";
				bt = b + bt;
				});
			bt = "<div class=\"bt\">" + bt + "</div>";

			var uw = "";
			var uf = "";
			$.each(data["uf"],function(index) {
				if (this.usewith) {
					uw += "<div class=\"uw\">";
					uw += "<a href=\"/catalog/combine.php?term=" + thcode + "-" + the_code + "&amp;with=" + thcode + "-" + this.usewith.code + "\"";
					uw += " onclick=\"show_use_with(" + thcode + ",'" + this.name + "'); return false;\"";
					uw += " title=\"USE " + data["term"].name + " WITH " + this.usewith.name + "\"";
					uw += ">";
					uw += this.name;
					uw += "</a>";
					uw += "</div>";
					}
				else {
					if (uf.length > 0) uf += ", ";
					uf += "<span class=\"uf\">";
					uf += this.name;
					uf += "</span>";
					}
				});

			var t = data["term"];
			var d  = "<div class=\"descriptor\">";
			d += "<div class=\"this-term\"";
			d += " title=\"Term code " + t.code + "\"";
			d += ">";
			d += t.name;
			d += "</div>";
			if ((t.scope != null && t.scope.length > 0) || uf.length > 0) {
				d += "<div class=\"sn\">";
				d += to_html(t.scope);
				if (uf.length > 0) d += "  Use for " + uf + ".";
				d += "</div>";
				}
			d += "</div>";
			var descriptor = d;

			var nt = "<div class=\"nt\">";
			$.each(data["nt"],function(index) {
				nt += "<div>";
				nt += "<a href=\"/catalog/science.php?thcode=" + thcode + "&amp;term=" + this.code + "\"";
				nt += " onclick=\"show_term(" + thcode + ",'" + this.code + "'); return false;\"";
				if (this.scope != null && this.scope.length > 0) nt += " title=\"" + htmlspecialchars(this.scope) + "\"";
				nt += ">";
				nt += this.name;
				nt += "</a>";
				nt += "</div>";
				});
			if (uw.length > 0) nt += "<br/>" + uw;
			nt += "</div>";

			var rt = "<div class=\"rt\">";
			$.each(data["rt"],function(index) {
				rt += "<div>";
				rt += "<a href=\"/catalog/science.php?thcode=" + thcode + "&amp;term=" + this.code + "\"";
				rt += " onclick=\"show_term(" + thcode + ",'" + this.code + "'); return false;\"";
				if (this.scope != null && this.scope.length > 0) rt += " title=\"" + htmlspecialchars(this.scope) + "\"";
				rt += ">";
				rt += this.name;
				rt += "</a>";
				rt += "</div>";
				});
			rt += "</div>";
			rt += "<div style=\"clear: both;\"></div>";

			$("#thesaurus-" + the_thcode).html("<div>" + bt + descriptor + nt + rt + "</div>");
			}
		});
	}

function toggle_vocab (the_thcode) {
	if ($('#check-' + the_thcode).prop('checked'))
		$.ajax ({
			url: "https://www2.usgs.gov/science/thesaurus.php",
			dataType: "jsonp",
			data: {
				thcode: the_thcode
				},
			success: function (data) {
				var tabTemplate = "<li thcode='#{thcode}'><a href='#{href}'>#{label}</a></li>";

				/* Is this vocabulary already one of the tabs? */

				var already_there = false;
				for (var i=0; i < thesauri.length; i++)
					if (thesauri[i].thcode == data.vocabulary.thcode) {
						already_there = true;
						break;
						}

				if (!already_there) {
					var the_id = "thesaurus-" + data.vocabulary.thcode;
					var the_name = data.vocabulary.name;
					if (data.vocabulary.altlabel.length > 0) {
						$.each (data.vocabulary.altlabel, function (i) {
							if (this.length < the_name.length) the_name = this;
							});
						}

					/* To the tab and its data pane, add an attribute thcode used when we want to remove the tab */

					var li = tabTemplate.replace(/#\{href\}/g, "#" + the_id).replace(/#\{thcode\}/g,data.vocabulary.thcode).replace(/#\{label\}/g,the_name);
					var q = $('#info').find('.ui-tabs-nav').append(li);
					$('#info').append("<div id='" + the_id + "' thcode='" + data.vocabulary.thcode + "'></div>");
					$('#info').tabs("refresh");
					show_term (data.vocabulary.thcode,data.vocabulary.root_code);
					/* Activate this tab? */
					$('#info').tabs("option","active",$('#' + the_id).index());

					/* Store info about this thesaurus in the thesauri array */

					var p = {
						"thcode": data.vocabulary.thcode,
						"label":  the_name,
						"root": data.vocabulary.root_code
						};
					var i = thesauri.length;
					thesauri[i] = p;
					}
				}
			});
	else {
		/* Vocabulary was un-checked.  First remove the tab, then the entry in the thesauri array */
		$("[thcode = '" + the_thcode + "']").remove();
		$('#info').tabs("refresh");
		for (var i=0; i < thesauri.length; i++)
			if (thesauri[i].thcode == the_thcode) {
				thesauri.splice(i,1);
				break;
				}
		}
	}

function show_vocabs() {
	$.ajax({
		url: "https://www2.usgs.gov/science/thesaurus.php",
		dataType: "jsonp",
		data: {
			},
		success: function (data) {
			var list = "<div>";
			$.each(data['vocabulary'],function(i) {
				var id = "vocab-" + i;
				list += "<div class=\"vocab-name\"><input type=\"checkbox\" id=\"check-" + this.thcode + "\" onchange=\"toggle_vocab(" + this.thcode + "); return false;\"/> <span onclick=\"$('#vocab-" + i + "').toggle(); return false;\">" + htmlspecialchars(this.name) + "<span></div>";
				list += "<div id=\"" + id + "\" class=\"vocab-details\">";
				list += "<div class=\"vocab-scope\">" + htmlspecialchars(this.scope) + "</div>";
				if (this.category.length > 0) {
					list += "<div class=\"vocab-category-list\">Characteristics: ";
					$.each (this.category,function(j) {
						list += ((j > 0) ? ", " : "") + "<span class=\"vocab-category\" title=\"" + htmlspecialchars(this.scope) + "\">" + htmlspecialchars(this.name) + "</span>";
						});
					list += "</div>";
					}
				list += "</div>";
				});
			list += "</div>";
			$("#vocabs").html(list);

			var p = {
				"thcode": "any",
				"label": "Vocabularies",
				"root": false
				};
			thesauri[0] = p;
			}
		});
	}

var thesauri = [];

$(document).ready(function(){
	show_vocabs();

	$('#info').tabs().resizable();

	for (var i=0; i < thesauri.length; i++) {
		show_term (thesauri[i].thcode,thesauri[i].root);
		}

	$('#st').autocomplete({
		source: function (request, response) {
			$.ajax({
				url: "https://www2.usgs.gov/science/term-search.php",
				dataType: "jsonp",
				data: {
					term: request.term,
				/*	thcode: thesauri[$('#info').tabs("option","active")].thcode */
					thcode: "any"
					},
				success: function (data) {
					response($.map(data, function (item) {
						for (var i=0; i < thesauri.length; i++)
							if (item.thcode == thesauri[i].thcode)
								return { label: item.label, value: item.value, thcode: item.thcode, code: item.code }
						}));
					}
				}); //---end of ajax piece
			},
		minLength: 1,
		select: function (event, ui) {
			},
		open: function () {
			},
		close: function () {
			},
		focus: function (event, ui) {
			var thcode = thesauri[$('#info').tabs("option","active")].thcode;

			var the_code = ui.item.code;
			if (Array.isArray(ui.item.code)) {
				the_code = ui.item.code[0];
				for (var i=1; i < ui.item.code.length; i++) the_code += "," + ui.item.code[i];
				}

			$.ajax({
				url: "https://www2.usgs.gov/science/term.php",
				dataType: "jsonp",
				data: {
					code: the_code,
					thcode: ui.item.thcode
					},
				success: function (data) {
					/* Focused item is a use-with term */
					if (Array.isArray(data)) {
						var d = "<div class=\"descriptor\">";

						var the_text = "";
						if (data.length == 2) {
							var p = data[0];
							var q = data[1];
							$.each(p.uf,function(j) {
								if (this.usewith && this.usewith.code == q.term.code) {
									if (the_text.length == 0) the_text = this.name;
									else the_text += ", " + this.name;
									}
								});
							}
						if (the_text.length == 0) the_text = "Coordinated terms";

						d += "<div class=\"this-term\">" + the_text + "</div>";
						d += "<div class=\"sn\">Information about ";
						$.each(data,function(i) {
							if (i > 0) d += " and ";
							d += "<a href=\"/catalog/science.php?thcode=" + this.thcode + "&amp;code=" + this.term.code + "\"";
							d += " onclick=\"show_term(" + this.thcode + ",'" + this.term.code + "'); return false;\"";
							if (this.term.scope != null && this.term.scope.length > 0) d += " title=\"" + htmlspecialchars(this.term.scope) + "\"";
							d += ">";
							d += this.term.name;
							d += "</a>";
							});
						d += "</div>";
						d += "</div>";

						thcode = data[0].thcode;

						var tab_id = "#thesaurus-" + thcode;

						for (var i=0; i < thesauri.length; i++)
							if (thesauri[i].thcode == thcode)
								$('#info').tabs ("option","active",i);

						$(tab_id).html("<div>" + d + "</div>");
						}
					else {
						thcode = data.thcode;
						/* Focused item is a descriptor */
						var bt = "";
						var n = data["bt"].length;
						$.each(data["bt"],function(index) {
							var b = "";
							if (index < n - 1) b += " &gt; ";
							b += "<a href=\"/catalog/science.php?thcode=" + thcode + "&amp;code=" + this.code + "\"";
							b += " onclick=\"show_term(" + thcode + ",'" + this.code + "'); return false;\"";
							if (this.scope != null && this.scope.length > 0) b += " title=\"" + htmlspecialchars(this.scope) + "\"";
							b += ">";
							b += this.name;
							b += "</a>";
							bt = b + bt;
							});
						bt = "<div class=\"bt\">" + bt + "</div>";

						var uw = "";
						var uf = "";
						$.each(data["uf"],function(index) {
							if (this.usewith) {
								uw += "<div class=\"uw\">";
								uw += "<a href=\"/catalog/combine.php?term=" + thcode + "-" + data["term"].code + "&amp;with=" + thcode + "-" + this.usewith.code + "\"";
								uw += " title=\"USE " + data["term"].name + " WITH " + this.usewith.name + "\"";
								uw += ">";
								uw += this.name;
								uw += "</a>";
								uw += "</div>";
								}
							else {
								if (uf.length > 0) uf += ", ";
								uf += "<span class=\"uf\">";
								uf += this.name;
								uf += "</span>";
								}
							});

						var t = data["term"];
						var d  = "<div class=\"descriptor\">";
						d += "<div class=\"this-term\"";
						d += " title=\"term code " + t.code + "\"";
						d += ">";
						d += t.name;
						d += "</div>";
						if (t.scope != null && t.scope.length > 0) {
							d += "<div class=\"sn\">";
							d += to_html(t.scope);
							if (uf.length > 0) d += "  Use for " + uf + ".";
							d += "</div>";
							}
						d += "</div>";
						var descriptor = d;

						var nt = "<div class=\"nt\">";
						$.each(data["nt"],function(index) {
							nt += "<div>";
							nt += "<a href=\"/catalog/science.php?thcode=" + thcode + "&amp;term=" + this.code + "\"";
							nt += " onclick=\"show_term(" + thcode + ",'" + this.code + "'); return false;\"";
							if (this.scope != null && this.scope.length > 0) nt += " title=\"" + htmlspecialchars(this.scope) + "\"";
							nt += ">";
							nt += this.name;
							nt += "</a>";
							nt += "</div>";
							});
						if (uw.length > 0) nt += "<br/>" + uw;
						nt += "</div>";

						var rt = "<div class=\"rt\">";
						$.each(data["rt"],function(index) {
							rt += "<div>";
							rt += "<a href=\"/catalog/science.php?thcode=" + thcode + "&amp;term=" + this.code + "\"";
							rt += " onclick=\"show_term(" + thcode + ",'" + this.code + "'); return false;\"";
							if (this.scope != null && this.scope.length > 0) rt += " title=\"" + htmlspecialchars(this.scope) + "\"";
							rt += ">";
							rt += this.name;
							rt += "</a>";
							rt += "</div>";
							});
						rt += "</div>";
						rt += "<div style=\"clear: both;\"></div>";

						var tab_id = "#thesaurus-" + thcode;

						for (var i=0; i < thesauri.length; i++)
							if (thesauri[i].thcode == thcode)
								$('#info').tabs ("option","active",i);

						$(tab_id).html("<div>" + bt + descriptor + nt + rt + "</div>");
						}
					}
				});
			}
		});
	});
